﻿using GrapeCity.Windows.SpreadGrid;
using GrapeCity.Windows.SpreadGrid.Editors;
using GrapeCity.Windows.SpreadGrid.Presenters;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.Drawing;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace SpreadSample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ObservableCollection<Product> products;
        public MainWindow()
        {
            InitializeComponent();
            products = new ObservableCollection<Product>();
            Random random = new Random();           
            for(int i=1;i<10;i++)
            {
                products.Add(new Product() { Id = i, Name = "Product " + i, Price = random.Next(10, 10000)});
            }
            spread.ItemsSource = products;
            spread.CanUserSortColumns = true;
            spread.Sorted += Spread_Sorted;
            spread.ColumnHeaderStyle = this.FindResource("headerStyle") as Style;
        }

        private async void Spread_Sorted(object sender, EventArgs e)
        {
            //Re-apply Column Header style
            spread.ColumnHeaderStyle = null;
            await Task.Delay(100);
            spread.ColumnHeaderStyle = this.FindResource("headerStyle") as Style;
        }

    }

    public class Product
    {
        public int Id { get; set; }
        public string Name { get; set; }
        public double Price { get; set; }
    }
    public class ValueConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            var spread = parameter as GcSpreadGrid;
            if (spread.Columns[(int)value].SortDirection == System.ComponentModel.ListSortDirection.Ascending)
                return "Ascending";
            else if (spread.Columns[(int)value].SortDirection == System.ComponentModel.ListSortDirection.Descending)
                return "Descending";
            else
                return null;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return null;
        }
    }

}
